angular.module('jlpt_test', ['ngSanitize'])
  .controller('TestController', ['$scope', '$rootScope',  function($scope, $rootScope) {
    
     $scope.onReady = false;
     $scope.showAnswer = false;
     $scope.state = 'testing';
     $scope.currentPart = 0;
     var safeApply = function () {
            if ($scope.$root.$$phase != '$apply' 
                && $scope.$root.$$phase != '$digest') {
                $scope.$apply();
            }
        };
      
      var reTag = function (str) {
            if (str == null)
                return null;

            var newStr = str.replace(/</g, "<ruby>").replace(/\(/g, "<rt>").replace(/\)>/g, "</rt></ruby>").replace(/{/g,"<u>").replace(/}/g,"</u>");

            return newStr;
        }
      
     $rootScope.showAnswerResult = function () {
        $scope.state = 'testing';
        $scope.showAnswer = true;
        safeApply();
    }
     
     $rootScope.caculateScore = function () {
            var test = $scope.questPart[$scope.currentPart];
            var meta = $scope.meta.parts[$scope.currentPart];
            var rightAnswerByParts = 0;

            var countAnswered = 0;
            rightAnswerByParts = 0;
            var questions = test.questions;
            if (questions == null) return 0;

            for (var j = 0; j < questions.length; j++) {
                var q = questions[j];
                if (q.subQuestions != null) {
                    for (var k = 0; k < q.subQuestions.length; k++) {
                        var sq = q.subQuestions[k];

                        if (sq.uAnswer != null && sq.question != "れい") {
                            countAnswered++;

                            if (String(sq.uAnswer) == String(sq.correctAnswer)) {
                                rightAnswerByParts++;
                            }
                        }
                    }
                }

                if (q.uAnswer != null) {
                    countAnswered++;
                    if (String(q.uAnswer) == String(q.correctAnswer)) {
                        rightAnswerByParts++;
                    }
                }
            }

            var metaPart = meta;
            var scoreOfPart = Math.floor(metaPart.max_score / metaPart.total * rightAnswerByParts);


            return scoreOfPart;
        };
      
    
     $rootScope.setupData = function(data, partIndex, isSaveState) {
        var result = data;
        $scope.result = result;
        $scope.meta = result.meta;
        $scope.currentPart = partIndex;
        if (result.parts != null) {
            for (var i = 0; i < result.parts.length; i++) {
                var questions = result.parts[i].questions;
                if (questions == null) continue;

                for (var j = 0; j < questions.length; j++) {
                    var q = questions[j];
                    if (q.subQuestions != null) {
                        for (var k = 0; k < q.subQuestions.length; k++) {
                            var sq = q.subQuestions[k];
                            if(!isSaveState)
                                sq.question = reTag(sq.question);

                            var answers = sq.answers;
                            if (answers == null || answers[0] == null) {
                                if (sq.correctAnswer != null) {
                                    sq.answers = ["1", "2", "3", "4"];
                                }
                                continue;
                            }

                            if(!isSaveState)
                                for (var m = 0; m < answers.length; m++) {
                                    answers[m] = reTag(answers[m]);
                                }
                        }
                    }

                    var answers = q.answers;
                    if (answers == null || answers[0] == null) {
                        if (q.correctAnswer != null) {
                            q.answers = ["1", "2", "3", "4"];
                        }
                        continue;
                    }
                    if(!isSaveState)
                        for (var m = 0; m < answers.length; m++) {
                            answers[m] = reTag(answers[m]);
                        }
                }
            }
        }

        $scope.questPart = result.parts;
        $scope.onReady = true;
        safeApply();
     }

      $rootScope.getTestPart = function () {
          return $scope.result.parts[$scope.currentPart];
      }
      
    $scope.getClassOfChoice = function (question, index) {
        if ($scope.showAnswer == false || 
            question.uAnswer == null || 
            index != parseInt(question.uAnswer))
            return 'test-choice';
        if (String(question.uAnswer) == String(question.correctAnswer)) {
            return "choice-right";
        } else {
            return "choice-false";
        }
    };

    callLoadDone();

  }]);

  // data is test data in string
  function sendDataFromNative (data, partIndex, isSaveState) {
      var $body = angular.element(document.body);            // 1
      var $rootScope = $body.injector().get('$rootScope');   // 2b
      $rootScope.setupData(data, partIndex, isSaveState);
  }

  function getCurrentTestState() {
      var $body = angular.element(document.body);            // 1
      var $rootScope = $body.injector().get('$rootScope');   // 2b

      var currentTestPart = $rootScope.getTestPart();
      if (window.JSInterface) {
          window.JSInterface.getTestPart(JSON.stringify(currentTestPart));
      } else {
          console.log("Not found js interface");
      }
  }

  function getScoreOfPart() {
      var $body = angular.element(document.body);            // 1
      var $rootScope = $body.injector().get('$rootScope');   // 2b

      var score = $rootScope.caculateScore();
      if (window.JSInterface) {
        window.JSInterface.getScoreOfPart(score);
      } else {
        console.log("Not found js interface");
      }
  }


  function showAnswer() {
      var $body = angular.element(document.body);            // 1
      var $rootScope = $body.injector().get('$rootScope');   // 2b

      $rootScope.showAnswerResult();
  }

  function callLoadDone() {
       if (window.JSInterface) {
           window.JSInterface.loadDone();
       } else {
           console.log("Not found js interface");
       }
  }